#include <kdialog.h>
#include <klocale.h>
#ifndef KMM_I18N
#define KMM_I18N
inline QString kmm_i18n(const char* msg, const char* ctx) { return i18n(ctx, msg); }
inline QString kmm_i18n(const char* msg) { return i18n(msg); }
#endif
/****************************************************************************
** Form implementation generated from reading ui file './ksettingsgpgdecl.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "ksettingsgpgdecl.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qcheckbox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <klineedit.h>
#include <kled.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a KSettingsGpgDecl as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
KSettingsGpgDecl::KSettingsGpgDecl( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setProperty( "name", "KSettingsGpgDecl" );
    KSettingsGpgDeclLayout = new QVBoxLayout( this, 11, 6, "KSettingsGpgDeclLayout"); 

    kcfg_WriteDataEncrypted = new QCheckBox( this, "kcfg_WriteDataEncrypted" );
    KSettingsGpgDeclLayout->addWidget( kcfg_WriteDataEncrypted );

    m_idGroup = new QGroupBox( this, "m_idGroup" );
    m_idGroup->setProperty( "enabled", QVariant( FALSE, 0 ) );
    m_idGroup->setColumnLayout(0, Qt::Vertical );
    m_idGroup->layout()->setSpacing( 6 );
    m_idGroup->layout()->setMargin( 11 );
    m_idGroupLayout = new QVBoxLayout( m_idGroup->layout() );
    m_idGroupLayout->setAlignment( Qt::AlignTop );

    textLabel2 = new QLabel( m_idGroup, "textLabel2" );
    textLabel2->setProperty( "alignment", int( QLabel::WordBreak | QLabel::AlignTop ) );
    m_idGroupLayout->addWidget( textLabel2 );

    layout7 = new QHBoxLayout( 0, 0, 6, "layout7"); 

    textLabel1 = new QLabel( m_idGroup, "textLabel1" );
    layout7->addWidget( textLabel1 );

    kcfg_GpgRecipient = new KLineEdit( m_idGroup, "kcfg_GpgRecipient" );
    layout7->addWidget( kcfg_GpgRecipient );

    m_userKeyFound = new KLed( m_idGroup, "m_userKeyFound" );
    m_userKeyFound->setProperty( "shape", "Circular" );
    m_userKeyFound->setProperty( "look", "Sunken" );
    layout7->addWidget( m_userKeyFound );
    m_idGroupLayout->addLayout( layout7 );
    KSettingsGpgDeclLayout->addWidget( m_idGroup );

    m_recoveryGroup = new QGroupBox( this, "m_recoveryGroup" );
    m_recoveryGroup->setProperty( "enabled", QVariant( FALSE, 0 ) );
    m_recoveryGroup->setColumnLayout(0, Qt::Vertical );
    m_recoveryGroup->layout()->setSpacing( 6 );
    m_recoveryGroup->layout()->setMargin( 11 );
    m_recoveryGroupLayout = new QVBoxLayout( m_recoveryGroup->layout() );
    m_recoveryGroupLayout->setAlignment( Qt::AlignTop );

    layout8 = new QHBoxLayout( 0, 0, 6, "layout8"); 

    kcfg_EncryptRecover = new QCheckBox( m_recoveryGroup, "kcfg_EncryptRecover" );
    layout8->addWidget( kcfg_EncryptRecover );
    spacer6 = new QSpacerItem( 51, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout8->addItem( spacer6 );

    m_recoverKeyFound = new KLed( m_recoveryGroup, "m_recoverKeyFound" );
    m_recoverKeyFound->setProperty( "shape", "Circular" );
    m_recoverKeyFound->setProperty( "look", "Sunken" );
    layout8->addWidget( m_recoverKeyFound );
    m_recoveryGroupLayout->addLayout( layout8 );

    textLabel3 = new QLabel( m_recoveryGroup, "textLabel3" );
    textLabel3->setProperty( "alignment", int( QLabel::WordBreak | QLabel::AlignTop ) );
    m_recoveryGroupLayout->addWidget( textLabel3 );
    KSettingsGpgDeclLayout->addWidget( m_recoveryGroup );
    spacer5 = new QSpacerItem( 21, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    KSettingsGpgDeclLayout->addItem( spacer5 );
    languageChange();
    resize( QSize(600, 490).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KSettingsGpgDecl::~KSettingsGpgDecl()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KSettingsGpgDecl::languageChange()
{
    setProperty( "caption", kmm_i18n( "GPG encryption settings" ) );
    QWhatsThis::add( this, kmm_i18n( "This page allows you to set the parameters for encrypted file storage of your <b>KMyMoney</b> data based on <b>GPG</b>.<p>\n"
"Acces to the settings is disabled if <b>GPG</b> could not be detected on your system. In this case, please make sure that <b>GPG</b> is function properly for the current user.<p>\n"
"The <i>Recovery encryption</i> group is only accessible, if the necessary key for <b>kmymoney-recover@users.sourceforge.net</b> with id 0x8AFDDC8E is found." ) );
    kcfg_WriteDataEncrypted->setProperty( "text", kmm_i18n( "Use GPG encryption" ) );
    m_idGroup->setProperty( "title", kmm_i18n( "User identification" ) );
    textLabel2->setProperty( "text", kmm_i18n( "Enter the id of the key you want to use for data encryption. This can either be an e-mail address or the hexadecimal key id. In case of the key id don't forget the leading 0x." ) );
    textLabel1->setProperty( "text", kmm_i18n( "User ID" ) );
    QWhatsThis::add( m_userKeyFound, kmm_i18n( "This symbol denotes, if the key for the given user id has been found in your keyring. It is green when found, dark otherwise." ) );
    m_recoveryGroup->setProperty( "title", kmm_i18n( "Recovery encryption" ) );
    kcfg_EncryptRecover->setProperty( "text", kmm_i18n( "Also encrypt with kmymoney-recover key" ) );
    QWhatsThis::add( m_recoverKeyFound, kmm_i18n( "This symbol denotes, if the KMyMoney recovery key has been found in your keyring. It is green when found, dark otherwise." ) );
    textLabel3->setProperty( "text", kmm_i18n( "You can specify to encrypt the data also with the KMyMoney recover key. Only the core KMyMoney developers are in posession of the respective private key required to read back such encrypted data.<p>\n"
"\n"
"This mechanism is provided for the case that you have lost your key and cannot access your data anymore. With this option activated, the KMyMoney developers can decrypt the data and supply you with it in a readable form. Please be prepared, that you have to answer a few detailed questions about the contents of your data before we will send it out.." ) );
}

#include "ksettingsgpgdecl.moc"
